# augment.awk
#
# Thu Feb 21 09:50:52  2002
#
# Uses the histogram of the classes (last column) to
# produce an augmented data file with balanced histogram.
# 
# requires filename of processed data as argument.
# standard input '-' is not allowed due to two pass processing.
# 
# Example:
#   awk -f augment.awk gurk.dat > gurk_plus.dat
#   produces a balances class representation of gurk.dat in gurk_plus.dat

BEGIN {
  srand()
  ARGC=3; ARGV[2] = ARGV[1]
}

!/(^#)|(^[ \t]*$)/ { 

  if(ARGIND == 1) {

    ++nr
    ++clss[$NF]

  }
  else { #  ARGIND == 2

    if(max == 0)  # first time only
      for(a in clss) if(clss[a] > max) max = clss[a] 


    c = clss[$NF]
    d = int(max/c)
    r = max % c

    for(i = 1; i <= d; i++) print

    if(rand() < r/c) print
  }
}

