# ztrans_inv.awk
#
# Thu Feb 21 10:20:29  2002
# 
# inverse z-transforms a given data set
# first two input lines must contain means and standard deviations of columns,
# possibly as given by ztrans.awk
#
# Example:
#   cat gurkZ_trans.dat | awk -f ztrans_inv.awk - gurkZ.dat > gurk.dat
#
#   inverse transforms all columns of gurkZ.dat with 
#   mean and standard deviations given in gurkZ_trans.dat

BEGIN {
  getline; for(i=1; i <= NF; i++) mean[i] = $i
  getline; for(i=1; i <= NF; i++) stdev[i] = $i
  nf = NF
}


{
  if(!($0 ~ /(^#)|(^[ \t]*$)/) && NF == nf) {
  
    for(i = 1; i <= nf; i++) {
      if(stdev[i] == 0)
        printf("%g ", $i)
      else
        printf("%g ", int(($i*sqrt(stdev[i])+mean[i])*100000+0.5)/100000)
    }
    printf("\n");
  }
  else
    print
}
